_Elasticsearch is an open source project and we love to receive contributions from our community — you! There are many ways to contribute, from writing tutorials or blog posts, improving the documentation, submitting bug reports and feature requests or writing code which can be incorporated into Elasticsearch itself._

Please read the [contributing guidelines][] which explain in detail how to contribute to Elasticsearch. The _short_ version is given below:

### For questions, please use the [forums](https://discuss.elastic.co/c/elasticsearch-and-hadoop) not the issue tracker

If you need help and have questions, please use the [forums](https://discuss.elastic.co/c/elasticsearch-and-hadoop) to ask questions. If on the other hand the code does not behave appropriately and you bumped into an error, use the issue tracker.

## Check the issue tracker

If you have a bug fix or new feature that you would like to contribute to Elasticsearch, please [find or open an issue][] about it first. Talk about what you would like to do. 
It may be that somebody is already working on it, or that there are particular issues that you should know about before implementing the change.

We enjoy working with contributors to get their code accepted. There are many approaches to fixing a problem and it is important to find the best approach before writing too much code.

## Fork and clone the repository

You will need to fork the main Elasticsearch code or documentation repository and clone it to your local machine. See [github documentation][] for help.

### Submitting your changes

Once your changes and tests are ready to submit for review:
### Test your changes

Run the test suite to make sure that nothing is broken.
### Sign the Contributor License Agreement

Please make sure you have signed our [Contributor License Agreement][]. We are not asking you to assign copyright to us, but to give us the right to distribute your code without restriction. We ask this of all contributors in order to assure our users of the origin and continuing existence of the code. You only need to sign the CLA once.

### Rebase your changes

Update your local repository with the most recent code from the main Elasticsearch repository, and rebase your branch on top of the latest master branch. We prefer your changes to be squashed into a single commit.

### Submit a pull request

Push your local changes to your forked copy of the repository and [submit a pull request][]. In the pull request, describe what your changes do and mention the number of the issue where discussion has taken place, eg “Closes #123″.

Then sit back and wait. There will probably be discussion about the pull request and, if any changes are needed, we would love to work with you to get your pull request merged into Elasticsearch.

[help documentation]: http://help.github.com/send-pull-requests
[github documentation]: http://help.github.com/articles/fork-a-repo
[contributing guidelines]: http://www.elasticsearch.org/contributing-to-elasticsearch/
[Contributor License Agreement]: http://www.elasticsearch.org/contributor-agreement/
[submit a pull request]: http://help.github.com/articles/using-pull-requests
[find or open an issue]: http://github.com/elasticsearch/elasticsearch-hadoop/issues
